<?php
class HistoryFiles
{
	private static $HistoryTypes = array(
	    'plugin_add'      => 1, // Плагин добавлен
	    'plugin_hide'     => 2, // Плагин скрыт
	    'plugin_show'     => 3, // Плагин показан
	    'plugin_deleted'  => 4, // Плагин удален
	    'plugin_restored' => 5, // Плагин востановлен
	    'plugin_locked'   => 6, //

	
	    'plugin_moderated_rank'   => 15, //
	    'plugin_moderated_main'   => 16, // 
	    'plugin_moderated_reqs'   => 17, // 
	    'plugin_moderated_tags'   => 18, //
	    'plugin_moderated_auth'   => 19, //   
	
	    'plugin_changed_title'   => 20, // 
	    'plugin_changed_otitle'  => 21, // 
 	    'plugin_changed_tags'    => 22, // 
	    'plugin_changed_authors' => 23, // 
	    'plugin_changed_reqs'    => 24, // 
	    'plugin_changed_ufiles'  => 25, // 
	    'plugin_changed_flink'   => 26, // 
	    'plugin_changed_slink'   => 27, // 
	    'plugin_changed_descr'   => 28, //
	    'plugin_changed_ver'     => 29, //  
	
	    'plugin_screen_add'       => 40, // 
	    'plugin_screen_hide'      => 41, // 
	    'plugin_screen_show'      => 42, // 
	    'plugin_screen_deleted'   => 43, // 
	    'plugin_screen_restored'  => 44, // 
	    'plugin_screen_moderated' => 45, // 
	    'plugin_screen_locked'    => 46, // 
	
	
	    'plugin_files_add'       => 60, // 
	    'plugin_files_hide'      => 61, // 
	    'plugin_files_show'      => 62, // 
	    'plugin_files_deleted'   => 63, // 
	    'plugin_files_restored'  => 64, // 
	    'plugin_files_moderated' => 65, // 
	    'plugin_files_locked'    => 66, //
	    'plugin_files_changed_title'       => 67, //
	    'plugin_files_changed_description' => 68, //
	    'plugin_files_changed_version'     => 69, //
	    'plugin_files_changed_file'        => 70,
	    'plugin_files_changed_priority'    => 71,

	
	    'plugin_patch_add'       => 80, // 
	    'plugin_patch_edited'    => 81, // 
	    'plugin_patch_show'      => 82, //
	    'plugin_patch_hide'      => 83, //  
	    'plugin_patch_deleted'   => 84, // 
	    'plugin_patch_restored'  => 85, // 
	    'plugin_patch_moderated' => 86, // 
	    'plugin_patch_locked'    => 87, //

	    
	    'plugin_links_add'       => 100, // 
	    'plugin_links_edited'    => 101, // 
	    'plugin_links_show'      => 102, //
	    'plugin_links_hide'      => 103, //  
	    'plugin_links_deleted'   => 104, // 
	    'plugin_links_restored'  => 105, // 
	    'plugin_links_moderated' => 106, // 
	    'plugin_links_locked'    => 107, // 

	
	    'plugin_author_add' => 120, // 
	    'plugin_author_del' => 121, // 

	);
	
	private static $HistoryTypesENV = array(
	    1   => array( 'plugin_add',                       'Дополнение добавлено' ),
	    2   => array( 'plugin_hide',                      'Дополнение скрыто' ),
	    3   => array( 'plugin_show',                      'Дополнение показано' ),
	    4   => array( 'plugin_deleted',                   'Дополнение удалено' ),
	    5   => array( 'plugin_restored',                  'Дополнение восстановлено' ),
	    6   => array( 'plugin_locked',                    'Дополнение заблокировано' ),
	    
	    15   => array( 'plugin_moderated_rank',           'Установлены оценки' ),
	    16   => array( 'plugin_moderated_main',           'Проверены основные данные' ),
	    17   => array( 'plugin_moderated_reqs',           'Проверены требования' ),
	    18   => array( 'plugin_moderated_tags',           'Проверены теги' ),
        19   => array( 'plugin_moderated_auth',           'Проверены авторы' ),
	
	    20  => array( 'plugin_changed_title',             'Изменено название' ),  
	    21  => array( 'plugin_changed_otitle',            'Изменено оригинальное название' ), 
 	    22  => array( 'plugin_changed_tags',              'Изменены теги' ),  
	    23  => array( 'plugin_changed_authors',           'Изменены авторы' ),
	    24  => array( 'plugin_changed_reqs',              'Изменены требования' ),  
	    25  => array( 'plugin_changed_ufiles',            'Изменены главыне файлы' ),  
	    26  => array( 'plugin_changed_flink',             'Изменена ссылка на обсуждение' ), 
	    27  => array( 'plugin_changed_slink',             'Изменена ссылка на источник' ), 
	    28  => array( 'plugin_changed_descr',             'Изменено описание' ),
	    29  => array( 'plugin_changed_ver',               'Изменена версия' ),  
	
	    40  => array( 'plugin_screen_add',                'Скриншот добавлен' ), 
	    41  => array( 'plugin_screen_hide',               'Скриншот скрыт' ), 
	    42  => array( 'plugin_screen_show',               'Скриншот показан' ), 
	    43  => array( 'plugin_screen_deleted',            'Скриншот удален' ),  
	    44  => array( 'plugin_screen_restored',           'Скриншот восстановлен' ), 
	    45  => array( 'plugin_screen_moderated',          'Скриншот прошел модерацию' ),  
	    46  => array( 'plugin_screen_locked',             'Скриншот заблокирован' ),  
	
	
	    60  => array( 'plugin_files_add',                 'Файл добавлен' ),  
	    61  => array( 'plugin_files_hide',                'Файл скрыт' ),  
	    62  => array( 'plugin_files_show',                'Файл показан' ),  
	    63  => array( 'plugin_files_deleted',             'Файл удален' ),  
	    64  => array( 'plugin_files_restored',            'Файл восстановлен' ),  
	    65  => array( 'plugin_files_moderated',           'Файл прошел модерацию' ),  
	    66  => array( 'plugin_files_locked',              'Файл заблокирован' ), 
	    67  => array( 'plugin_files_changed_title',       'Изменен заголовок файла' ), 
	    68  => array( 'plugin_files_changed_description', 'Изменено описание файла' ), 
	    69  => array( 'plugin_files_changed_version',     'Изменена версия файла' ),
	    70  => array( 'plugin_files_changed_file',        'Изменено содержимое файла' ),  
        71  => array( 'plugin_files_changed_priority',    'Изменен приоритет файла' ),
	
	    80  => array( 'plugin_patch_add',                 'Патч добвлен' ),  
	    81  => array( 'plugin_patch_edited',              'Патч отредактирован' ),  
	    82  => array( 'plugin_patch_show',                'Патч показан' ), 
	    83  => array( 'plugin_patch_hide',                'Патч скрыт' ),   
	    84  => array( 'plugin_patch_deleted',             'Патч удален' ),  
	    85  => array( 'plugin_patch_restored',            'Патч восстановлен' ),  
	    86  => array( 'plugin_patch_moderated',           'Патч прошел модерацию' ),  
	    87  => array( 'plugin_patch_locked',              'Патч заблокирован' ), 

	    
	    100 => array( 'plugin_links_add',                 'Ссылка добавлена' ), 
	    101 => array( 'plugin_links_edited',              'Ссылка отредактирована' ), 
	    102 => array( 'plugin_links_show',                'Ссылка показана' ),
	    103 => array( 'plugin_links_hide',                'Ссылка скрыта' ),  
	    104 => array( 'plugin_links_deleted',             'Ссылка удалена' ), 
	    105 => array( 'plugin_links_restored',            'Ссылка восстановлена' ), 
	    106 => array( 'plugin_links_moderated',           'Ссылка прошла модерацию' ), 
	    107 => array( 'plugin_links_locked',              'Ссылка заблокирована' ), 

	
	    120 => array( 'plugin_author_add',                'Добавлен автор' ), 
	    121 => array( 'plugin_author_del',                'Автор удален' ), 

	);
	
	
	public static function AddHistory( $fid, $type, $before, $after, $addit_id = 0 )
	{
		$fid = (int)$fid;
		$addit_id = (int)$addit_id;
		
		$types = self::$HistoryTypes;
		
		if( $types[$type] )
		    $type = $types[$type];
		else
		    return;
		    
		    
	   $uid  = User::GetId();
	   $date = date( 'U' );	  

	   $before = htmlspecialchars( $before );
	   $after  = htmlspecialchars( $after  );
	   
	   $insert = DBChose::PrepareDriver( 'INSERT INTO `fullrestu_site`.`files_history` ( `fid`, `uid`, `type`, `date`, `before`, `after`, `additional_id` ) VALUES( :1, :2, :3, :4, :5, :6, :7 )' );
       $insert->Execute( $fid, $uid, $type, $date, $before, $after, $addit_id );
	}
	
	
    public static function ShowTitle( $tid )
	{
	    return self::$HistoryTypesENV[$tid][1];
	}
	
	
}