<?php
class UrlDecoder implements IFS_UrlDecoder
{
    //--------------------------------------------------------------------------
    // PUBLIC VARS
    //--------------------------------------------------------------------------

    //--------------------------------------------------------------------------
    // PPRIVATE VARS
    //--------------------------------------------------------------------------

    private static $Uri    = array();
    private static $FType  = array();
    private static $Lev    = array();
    private static $Lock   = 0;       // Защита от повторного анализа URL.

    //--------------------------------------------------------------------------
    // PUBLIC FUNCTIONS
    //--------------------------------------------------------------------------

    public function __construct()
    {
        if( UrlDecoder::$Lock )
            return;

        self::UriReady();
        self::LevReady();

        UrlDecoder::$Lock = 1;
    } // END OF __construct()
      //------------------------------------------------------------------------

    public static function GetUri()
    {
        if( !UrlDecoder::$Lock )
            return;

        return UrlDecoder::$Uri;
    } // END OF GetUri()
      //------------------------------------------------------------------------
      
    public static function GetCUri( $index = 0 )
    {
        if( !UrlDecoder::$Lock )
            return;

        return UrlDecoder::$Uri[(int)$index];
    } // END OF GetCUri()
      //------------------------------------------------------------------------

    public static function GetLev()
    {
        if( !UrlDecoder::$Lock )
            return;

        return UrlDecoder::$Lev;
    } // END OF GetLev()
      //------------------------------------------------------------------------
      
    public static function GetCLev( $index = 0 )
    {
        if( !UrlDecoder::$Lock )
            return;

        return UrlDecoder::$Lev[(int)$index];
    } // END OF GetCLev()
      //------------------------------------------------------------------------

    public static function GetFType()
    {
        if( !UrlDecoder::$Lock )
            return;

        return UrlDecoder::$FType;
    } // END OF GetFType()
      //------------------------------------------------------------------------
      
    public static function SetUri( $uri )
    {
        UrlDecoder::$Uri = $uri;
    } // END OF GetUri()
      //------------------------------------------------------------------------


    //--------------------------------------------------------------------------
    // PRIVATE FUNCTIONS
    //--------------------------------------------------------------------------

    private function UriReady()
    {
        $url = mb_strtolower( $_SERVER['REQUEST_URI'], 'UTF-8' );
        
        if( 0 < strpos( $url, '?' ) )
            $url = substr( $url, 0, strpos( $url, '?' ) );


        $url  = substr( $url, 1 );     
        $url  = htmlspecialchars( $url );        
        $url  = explode( '/', $url );        
        $nur  = count( $url ) - 1;
               
        $type = explode( '.', $url[$nur] );

        if( sizeof( $type ) > 1 && $type[1] != '' )
        {
            $url[$nur] = substr( $url[$nur], 0, strpos( $url[$nur], '.' ) );
            
        	UrlDecoder::$FType = $type[1];
        }
        else
            UrlDecoder::$FType = 'none';

        if( $url[sizeof( $url ) - 1] == '' )
            unset( $url[sizeof( $url ) - 1] );             
            
        UrlDecoder::$Uri = $url;
    } // END OF UriReady()
      //------------------------------------------------------------------------

    private function LevReady()
    {
        $host  = strtolower( $_SERVER['HTTP_HOST'] );
        $array = explode( '.', $host );
        $num   = sizeof( $array );

        for( $a = $num - 1; $a >= 0; $a-- )
            $lev[] = $array[$a];
            
        if( $lev[2] == 'www' )
            base_redirect( 0, 'http://'.$lev[1].'.'.$lev[0].$_SERVER['REQUEST_URI'] );

        UrlDecoder::$Lev = $lev;
    } // END OF LevReady()
      //------------------------------------------------------------------------
}
?>