<?php
class User 
{	
	private static $TimeLive = 300; // 60 - 1 минута
	
	private static $status  = 'guest'; // guest, banned, waiting, logged
	private static $timer   = 0;
	private static $id      = 0;
	private static $nick    = 0;
	private static $page    = 0;
	private static $avatar  = array();
	private static $gender  = 0;
	private static $pgroup  = 0;
	private static $groups  = array();
	private static $arights = array();
	
	public static function GetStatus()      { return User::$status;      }
    public static function GetId()          { return User::$id ;         }
    public static function GetNick()        { return User::$nick;        }
    public static function GetPage()        { return User::$page;        }
    public static function GetAvatar( $i )  { return User::$avatar[$i];  }
    public static function GetGender()      { return User::$gender;      }
    public static function GetPGroup()      { return User::$pgroup;      }
    public static function GetCGroup( $id ) { return User::$groups[$id]; }
    public static function GetGroups()      { return User::$groups;      }
    
    public static function GetRight( $name )
    {
    	if( User::GetCGroup( 1 ) || User::GetCGroup( 5 )  )
    	    return true;
    	else if( User::$arights[$name] )
    	    return true;
    	        
    	return false;
    }
    
    public static function CanPost()
    {
    	if( !User::GetId() )
    	    return false;
    	else if( User::GetCGroup( 3  ) ) return false;
    	else if( User::GetCGroup( 4  ) ) return false;
    	else if( User::GetCGroup( 12 ) ) return false;     
    	else
    	    return true;   
    }
	
	
	public static function LoginAttempt( $email, $password )
	{
		if( User::$status != 'guest' )
		    return false;
		
		$email = mb_strtolower( $email, 'UTF-8' );
        $passw = htmlspecialchars( $password );        
          
        if( !RegEx::check_IsEmail( $email ) )
            return false;   

        $user_check = DBChose::PrepareDriver( 'SELECT * FROM  `members`,`members_auth` WHERE `email`=:1 AND `members`.`id`=`members_auth`.`id` ' );
        $user_check->Execute( $email );
         
        if( !$user_check->GetNum() )
            return false;  
        
        $data = $user_check->FetchAssoc();        
        
        $hash = User::PassHashGen( $passw, $email, $data['salt'] );
        
        if( $hash != $data['hash'] )
            return false;
             
            
        User::ReExecute( $data['id'] );
        
        $cookie = md5( User::PassSaltGen().date( 'U' ).sha1( $hash ) );
        
        $user_update = DBChose::PrepareDriver( 'UPDATE `members` SET `cook`=:1 WHERE `id`=:2' );
        $user_update->Execute( $cookie, $data['id'] );
        
        setcookie( 'FRB_USER_logged', $cookie, time() + 60*60*24*30*12, '/', '.fullrest.ru' );
        
        return true;
	}
	
	public static function Execute()
	{
        User::ReStoreData();

        if( User::$id != 0 )
            User::CheckUserInfo();
        else
            User::CheckUserCook();
		 
		User::StoreData(); 
	}
	
	public static function ReExecute( $id )
	{
		User::$id = $id;
        
        User::CheckUserInfo( 1 );
		 
		User::StoreData(); 
	}
	
    public static function MakeLogout()
    {
        $user_update = DBChose::PrepareDriver( 'UPDATE `members` SET `cook`=:1 WHERE `id`=:2' );
        $user_update->Execute( '', User::$id );
    	
    	User::ReExecute( 0 );    	
    }
	
    private static function CheckUserInfo( $timer_ignore = 0 )
    {
    	if( User::$timer + User::$TimeLive > date( 'U' ) && $timer_ignore == 0 )
    	    return;
    	    
    	$select_user = DBChose::PrepareDriver( 'SELECT * FROM `members` WHERE `id`=:1' );
        $select_user->Execute( User::$id );   

        if( !$select_user->GetNum() )
        {
        	User::LogOut();
        	return;
        }
        
        $user_data = $select_user->FetchAssoc();
        
        $user_groups[$user_data['group_primary']] = true;
        $user_group_ids[$user_data['group_primary']] = '\''.$user_data['group_primary'].'\'';
        
        $select_groups = DBChose::PrepareDriver( 'SELECT * FROM `members_secgroups` WHERE `uid`=:1' );
        $select_groups->Execute( User::$id );  
        
        $actual_rights = array();
        
        for( $a = 0; $a < $select_groups->GetNum(); $a++ )
        {
        	$row = $select_groups->FetchArray();
        	
        	$user_groups[$row['gid']] = true;  
        	$user_group_ids[$row['gid']] = '\''.$row['gid'].'\'';      	
        }
        
        //
        // -------------------------------------------------------------------- ВЫБОРКА ПРАВ >
        //
        $agroups = DBChose::PrepareDriver( 'SELECT * FROM `groups` WHERE `id` IN( '.implode( ' , ', $user_group_ids ).' )' );
        $agroups->Execute( User::$id );  
        
        for( $a = 0; $a < $agroups->GetNum(); $a++ )
        {
        	$row22 = $agroups->FetchAssoc();
        	
        	if( $user_data['id'] == $row22['ceo'] || $user_data['id'] == $row22['co_ceo'] )
        	{
        		$rsel1 = DBChose::PrepareDriver( 'SELECT * FROM  `sett_rights_glink` ,  `sett_rights_list` WHERE  `sett_rights_glink`.`gid` = :1 AND  `sett_rights_glink`.`right_id` =  `sett_rights_list`.`right_id` ' );
                $rsel1->Execute( $row22['id'] );

                for( $b = 0; $b < $rsel1->GetNum(); $b++ )
                {
                	$rrrrow = $rsel1->FetchAssoc();
                	
                	$actual_rights[$rrrrow['right_name']] = true;                	
                }
        	} 
        	
        }
        
        $rsel2 = DBChose::PrepareDriver( 'SELECT * FROM `sett_rights_glink` ,  `sett_rights_list` WHERE  `sett_rights_glink`.`gid` IN( '.implode( ' , ', $user_group_ids ).' ) AND `sett_rights_glink`.`gid` = :1 AND  `sett_rights_glink`.`right_id` =  `sett_rights_list`.`right_id` ' );
        $rsel2->Execute( 1 );
        
        for( $b = 0; $b < $rsel2->GetNum(); $b++ )
        {
            $rrrrow = $rsel2->FetchAssoc();
                	
            $actual_rights[$rrrrow['right_name']] = true;                	
        }
        
        $rsel3 = DBChose::PrepareDriver( 'SELECT  `sett_rights_list` . * 
FROM  `groups_ranks_links` ,  `groups_ranks_rlinks` ,  `sett_rights_list` 
WHERE  `groups_ranks_links`.`uid` =  :1
AND  `groups_ranks_links`.`rid` =  `groups_ranks_rlinks`.`rank_id` 
AND  `groups_ranks_rlinks`.`right_id` =  `sett_rights_list`.`right_id` ' );
        $rsel3->Execute( $user_data['id'] );
        
        for( $b = 0; $b < $rsel3->GetNum(); $b++ )
        {
            $rrrrow = $rsel3->FetchAssoc();
                	
            $actual_rights[$rrrrow['right_name']] = true;                	
        }
        
        /*PrintArrayDump( $actual_rights );
        exit;*/
        
        //
        // -------------------------------------------------------------------- ВЫБОРКА ПРАВ <
        //        
        
        if( $user_data['group_primary'] == 4 )
            User::$status = 'waiting';
        elseif( $user_data['group_primary'] != 3 )
            User::$status = 'logged';
        else
            User::$status = 'guest';
            
        if( User::$status != 'guest' )  
        {
        	$online_update = DBChose::PrepareDriver( 'UPDATE `members` SET `last_online`=:2 WHERE `id`=:1' );
            $online_update->Execute( User::$id, date( 'U' ) ); 
        }  
        
        User::$timer   = date( 'U' );
        User::$id      = $user_data['id'];
        User::$nick    = $user_data['nick'];
        User::$page    = $user_data['page'];
        User::$avatar  = array( 'width' => $user_data['avatar_w'], 'height' => $user_data['avatar_h'], 'type' => $user_data['avatar_type'] );    
        User::$gender  = $user_data['gender'];
        User::$pgroup  = $user_data['group_primary'];
        User::$groups  = $user_groups; 
        User::$arights = $actual_rights;
        
    }
    
    private static function CheckUserCook()
    {
    	if( !$_COOKIE['FRB_USER_logged'] )
    	    return;
    	    
    	$cookie = $_COOKIE['FRB_USER_logged'];
    	
        $select_user = DBChose::PrepareDriver( 'SELECT * FROM `members` WHERE `cook`=:1' );
        $select_user->Execute( $cookie );   

        if( !$select_user->GetNum() )
        {
        	User::LogOut();
        	return;
        }
        
        $user_data = $select_user->FetchAssoc();        
        User::$id  = $user_data['id'];
        
        User::CheckUserInfo( 1 );
    }
    
    private static function LogOut()
    {
        User::$status = 'guest';
        User::$timer  = 0;
        User::$id     = 0;
        User::$nick   = 0;
        User::$page   = 0;
        User::$gender = 0;
        User::$pgroup = 0;
        User::$groups = array();    	
    }
	
	private static function StoreData()
	{
        $in_array = array(
            'here_iam' => 'yep',
            'main'     => array(
                'status'  => User::$status,
                'timer'   => User::$timer,
                'id'      => User::$id,
                'nick'    => User::$nick,
                'page'    => User::$page,
                'avatar'  => User::$avatar,
                'gender'  => User::$gender,
                'pgroup'  => User::$pgroup,
                'groups'  => User::$groups,
                'arights' => User::$arights,
            ),
            
            
        
        );
		
		
		$_SESSION['FRB_USER_DATA'] = $in_array;
		 
		
	}
	
    private static function ReStoreData()
	{
        if( $_SESSION['FRB_USER_DATA']['here_iam'] != 'yep' )
            return false;
		
		User::$status  = $_SESSION['FRB_USER_DATA']['main']['status'];
		User::$timer   = $_SESSION['FRB_USER_DATA']['main']['timer'];
        User::$id      = $_SESSION['FRB_USER_DATA']['main']['id'];
        User::$nick    = $_SESSION['FRB_USER_DATA']['main']['nick'];
        User::$page    = $_SESSION['FRB_USER_DATA']['main']['page'];
        User::$avatar  = $_SESSION['FRB_USER_DATA']['main']['avatar'];
        User::$gender  = $_SESSION['FRB_USER_DATA']['main']['gender'];
        User::$pgroup  = $_SESSION['FRB_USER_DATA']['main']['pgroup'];
		User::$groups  = $_SESSION['FRB_USER_DATA']['main']['groups']; 
		User::$arights = $_SESSION['FRB_USER_DATA']['main']['arights']; 
		
		/*PrintArrayDump( User::$arights );				
        exit;*/
		
		return true;
	}
	
    public static function PassSaltGen()
    {
        $salt  = ''; 

        for( $a = 0; $a < 32; $a++ )
            $salt .= chr( rand( 48, 122 ) );
            
        return htmlspecialchars( $salt );        	
    }
    
    public static function PassHashGen( $pass, $email, $salt )
    {            
        return md5( md5( $pass ).$email.sha1( $salt ) );        	
    }
}
?>