<?php
class SonetUserPage
{
	private static $SYSOnlineTimer = 600; // Время онлайна считается: 10 минут (600 секунд)
	
	private static $PageId     = 0;
	private static $PageUri    = '';
	private static $PageTitle  = '';
	private static $PageAvatar = array();
	private static $PageGender = 'male';
	
	private static $PageName        = '';
	private static $PagePatronymic  = '';
	
	private static $PageStatuse     = '';
	
	private static $PageOwner  = false;	
	private static $PageOnline = false;
	private static $PageInvis  = false;
	
	private static $ListFriend = false;
	private static $ListIgnore = false;
	private static $ListFOF    = false; // ДРУГ ДРУГА
	
	public static function GetId()          { return SonetUserPage::$PageId;          }
	public static function GetUri()         { return SonetUserPage::$PageUri;         }
	public static function GetTitle()       { return SonetUserPage::$PageTitle;       }
    public static function GetAvatar( $i )  { return SonetUserPage::$PageAvatar[$i];  }
    public static function GetGender()      { return SonetUserPage::$PageGender;      }
	
    public static function GetName()        { return SonetUserPage::$PageName;        }
	public static function GetPatronymic()  { return SonetUserPage::$PagePatronymic;  }
    public static function GetStatuse( $i ) { return SonetUserPage::$PageStatuse[$i]; }
	
    public static function GetOnLine() { return SonetUserPage::$PageOnline; }
	public static function GetInvis()  { return SonetUserPage::$PageInvis;  }
	
	public static function GetIsOwner()  { return SonetUserPage::$PageOwner;  }
    public static function GetIsFriend() { return SonetUserPage::$ListFriend; }
    public static function GetIsFOF()    { return SonetUserPage::$ListFOF;    }
    public static function GetIsIgnore() { return SonetUserPage::$ListIgnore; }
	
	
	
	public static function CheckPage( $module_name )
	{
		if( SonetUserPage::$PageId )
		    return false;
		
		$check = DBChose::PrepareDriver( 'SELECT * FROM `members` WHERE `page`=:1' );
    	$check->Execute( $module_name );
    	
    	if( !$check->GetNum() )
    	    return false;
    	    
    	$row = $check->FetchAssoc();
    	
    	if( User::GetId() == $row['id'] )
    	    SonetUserPage::$PageOwner = true;
    	
    	SonetUserPage::$PageId     = $row['id'];
    	SonetUserPage::$PageUri    = $row['page'];
    	SonetUserPage::$PageTitle  = $row['nick'];    	
    	SonetUserPage::$PageAvatar = array( 'width' => $row['avatar_w'], 'height' => $row['avatar_h'], 'type' => $row['avatar_type'] );
    	SonetUserPage::$PageGender = $row['gender'];  
    	
    	$personal = DBChose::PrepareDriver( 'SELECT * FROM `members_personal` WHERE `id`=:1' );
    	$personal->Execute( $row['id'] );
    	
    	$row2 = $personal->FetchAssoc();
    	
    	SonetUserPage::$PageName       = $row2['name'];
    	SonetUserPage::$PagePatronymic = $row2['patronymic'];
    	
        $status = DBChose::PrepareDriver( 'SELECT * FROM `members_statuses` WHERE `uid`=:1 ORDER BY `members_statuses`.`date` DESC LIMIT 0 , 1' );
    	$status->Execute( $row['id'] );
    	
    	$row3 = $status->FetchAssoc();
    	
    	SonetUserPage::$PageStatuse = $row3;

    	if( !$row['invisible'] )
    	{    		
    		if( date( 'U' ) - $row['last_online'] <= SonetUserPage::$SYSOnlineTimer )
    		    SonetUserPage::$PageOnline = true;
    	}
    	else
    	    SonetUserPage::$PageInvis = true;
    	
    	if( !SonetUserPage::$PageOwner )
    	    SonetUserPage::CheckLists();
    	
    	if( User::GetId() )
    	    SonetUserPage::SetVisit();
    	
    	return true;
	}
	
	public static function CheckAccess( $val )
	{
		$value = (int)$val;
		
		if( $val > 5 || $val < 0 )
		    return false;
		    
		// 0 > Нет
        // 1 > Только мне
        // 2 > Всем
        // 3 > Зарегистрированным
        // 4 > Только друзьям
        // 5 > Друзьям друзей 

		if( $val == 0 )
		    return false;
		else if( $val == 1 )
		{
			if( SonetUserPage::GetIsOwner() )
			    return true;
			else
			    return false;
		}
		else if( $val == 2 )
		    return true;
		else if( $val == 3 )
		{
			if( User::GetId() )
			    return true;
			else
			    return false;
		}
		else if( $val == 4 )
		{
			if( SonetUserPage::GetIsFriend() || SonetUserPage::GetIsOwner() )
			    return true;
			else
			    return false;			
		}
	    else if( $val == 5 )
		{
			if( SonetUserPage::GetIsFriend() || SonetUserPage::GetIsOwner() )
			    return true;
			else
			    return false;			
		}			
		else
		    return false;    
	}
	
	
	
    private static function SetVisit()
	{
		if( SonetUserPage::$PageOwner )
		    return;

		$chk = DBChose::PrepareDriver( 'SELECT * FROM `members_visitors` WHERE `page_id`=:1 AND `visitor_id`=:2' );
    	$chk->Execute( SonetUserPage::$PageId, User::GetId() );   

    	if( !$chk->GetNum() )
    	{
    		$chk = DBChose::PrepareDriver( 'INSERT INTO `members_visitors` ( `page_id`, `visitor_id`, `visit_date` ) VALUES( :1, :2, :3 )' );
    	    $chk->Execute( SonetUserPage::$PageId, User::GetId(), date( 'U' ) ); 
    	}
    	else
	    {
    		$upd = DBChose::PrepareDriver( 'UPDATE `members_visitors` SET `visit_date` =:3 WHERE `page_id`=:1 AND `visitor_id`=:2' );
    	    $upd->Execute( SonetUserPage::$PageId, User::GetId(), date( 'U' ) ); 
    	}
	}
	
	private static function CheckLists()
	{
		$friend = DBChose::PrepareDriver( 'SELECT * FROM `members_friendlist` WHERE ( ( `from`=:1 AND `to`=:2 )  OR ( `from`=:2 AND `to`=:1 ) ) AND `confirm`=:3 ' );
    	$friend->Execute( User::GetId(), SonetUserPage::$PageId, 1 );
    	
    	if( $friend->GetNum() )
    	    SonetUserPage::$ListFriend = true;
    	    
    	$ignore = DBChose::PrepareDriver( 'SELECT * FROM `members_ignore_list` WHERE `owner_id`=:1 AND `ignore_id`=:2' );
    	$ignore->Execute( SonetUserPage::$PageId, User::GetId() );
    	
    	if( $ignore->GetNum() )
    	    SonetUserPage::$ListIgnore = true;    	
	}
}