<?php
/*******************************************************************************
FILE:    interface_UrlDecoder.php
VERSION: 1.0c
AUTHOR:  Dmitry "Saint Spark" Pustovit
E-MAIL:  spark@saint-spark.com
SITE:    http://saint-spark.com
--------------------------------------------------------------------------------
Это интерфейс для стандартных декодеров ссылки, каждый такой декодер должен
содержать пользовательские функции, приведенные ниже, остальные же функции
олжны быть скрыты:
*******************************************************************************/
interface IFS_UrlDecoder
{
    public static function GetUri();
    /*--------------------------------------------------------------------------
    Функция предназначена для получения разобранного URI типа
    “news/archive/2008/article.html”, функция должна вернуть массив
    следующего формата:
        [0] = news
        [1] = archive
        [2] = 2008
        [3] = article
    --------------------------------------------------------------------------*/

    public static function GetLev();
    /*--------------------------------------------------------------------------
    Данная функция осуществляет разбор доменного имени на компоненты, для
    примера “www.level4.level3.saint-spark.com”, возврат функции должен
    быть массив следующего формата:
        [0] = com
        [1] = saint-spark
        [2] = level3
        [3] = level4
        [4] = www
    --------------------------------------------------------------------------*/

    public static function GetFType();
    /*--------------------------------------------------------------------------
    Возвращает тип документа для “news/archive/2008/article.html” возврат будет
    строкой “html”, при отсутствии типа документа, вернет “none”.
    --------------------------------------------------------------------------*/

    //public static function GetSite();
    /*--------------------------------------------------------------------------
    Функция должна вернуть название домена, причем для доменов 2го уровня она
    убирает ведущие www если они есть, ниже приведены результаты работы
    функции в следующем формате: [домен] = {возврат функции}

        [saint-spark.com]         = {saint-spark.com}
        [www.saint-spark.com]     = {saint-spark.com}
        [www.sub.saint-spark.com] = {www.sub.saint-spark.com}
        [sub.saint-spark.com]     = {sub.saint-spark.com}
    --------------------------------------------------------------------------*/

}

?>