<?php

class Module extends PModule
{
    public function act_index()
    { 		       	        	    
  	    parent::SetTemplModule( 'authorization' );
  	    
  	    if( UrlDecoder::GetCUri( 0 ) == 'authorization' )
  	        $this->module_authorization();
  	    elseif( UrlDecoder::GetCUri( 0 ) == 'registration' )
  	        $this->module_registration();
  	    elseif( UrlDecoder::GetCUri( 0 ) == 'logout' )
  	        $this->module_logout();
  	    elseif( UrlDecoder::GetCUri( 0 ) == 'confirm-request' )
  	        $this->module_request();      
    }
    
    private function module_request()
    {
    	parent::AddBreadCorn( 'confirm-request', 'Реактивация', '' );
    	parent::SetTitle( 'Реактивация' );
    	parent::SetReturnCData( 'title', 'Реактивация' ); 
    	
        if( !User::CanPost() )
    	{    		
            $page1_check = DBChose::PrepareDriver( 'SELECT * FROM  `members` WHERE `id`=:1' );
            $page1_check->Execute( User::GetId() );
            
            $page_check = DBChose::PrepareDriver( 'SELECT * FROM  `members_auth` WHERE `id`=:1' );
            $page_check->Execute( User::GetId() );
        
            $user  = $page_check->FetchAssoc();
            $user1 = $page1_check->FetchAssoc();
            
            $subject = "Подтверждение регистрации Fullrest: SONET";
              

            $mail_text = 
"ВНИМАНИЕ!!! Это письмо прислано автоматизированный системой рассылки уведомлений ресурса fullrest.ru. Вы не должны отвечать на данное сообщение.

Если же вы действительно регистрировались на нашем ресурсе, то для активации учетной записи вам следует пройти по ссылке ниже.

Ссылка для активации: ".SHOST.'/registration/confirm/'.$user['eactive']."

Если вы не регистрировались на сайте fullrest.ru и вы не знаете, кто мог указать ваш почтовый ящик во время регистрации, тогда пройдите по ссылке ниже и данный ящик будет удален из нашей базы:

Ссылка для удаления: ".SHOST.'/registration/delete/'.$user['eactive']."

Благодарим за регистрацию на нашем сайте!

С уважение, Fullrest-Team.";
        
            $send = send_my_email( $user1['email'], $subject, $mail_text );
            
            parent::SetReturnCData( 'complete', true );
    	}
    }
    
    private function module_authorization()
    {
    	parent::AddBreadCorn( 'authorization', 'Авторизация', '' );
    	parent::SetTitle( 'Система авторизации' );
    	parent::SetReturnCData( 'title', 'Система авторизации' ); 
    	
    	if( $_POST['sender'] )
    	{    		
    		if( User::LoginAttempt( $_POST['email'], $_POST['pass'] ) )
    		    base_redirect( 0, OldUrl::GetCUrl( 1 ) );
    		else
    		    define( 'author_error', true );
    	}
    }
    
    private function module_registration()
    {
    	if( UrlDecoder::GetCUri( 1 ) == 'confirm' )
    	{
    		$this->registr_activation();
    		return;
    	}
    	else if( UrlDecoder::GetCUri( 1 ) == 'delete' )
    	{
    		$this->registr_delete();
    		return;
    	}
        else if( UrlDecoder::GetCUri( 1 ) == 'restore' )
    	{
    		$this->registr_restore();
    		return;
    	}
    	
    	parent::AddBreadCorn( 'registration', 'Регистрация', '' );
    	parent::SetTitle( 'Регистрация нового пользователя' );
    	parent::SetReturnCData( 'title', 'Регистрация нового пользователя' ); 
    	

$months = array( 
  1 => array( 'days' => 31, 'title' => 'Январь'   ), 2  => array( 'days' => 28, 'title' => 'Февраль'  ),  3  => array( 'days' => 31, 'title' => 'Март'     ),  4  => array( 'days' => 30, 'title' => 'Апрель'   ), 
  5 => array( 'days' => 31, 'title' => 'Май'      ), 6  => array( 'days' => 30, 'title' => 'Июнь'     ),  7  => array( 'days' => 31, 'title' => 'Июль'     ),  8  => array( 'days' => 31, 'title' => 'Август'   ),
  9 => array( 'days' => 30, 'title' => 'Сентябрь' ), 10 => array( 'days' => 31, 'title' => 'Октябрь'  ),  11 => array( 'days' => 30, 'title' => 'Ноябрь'   ),  12 => array( 'days' => 31, 'title' => 'Декабрь'  ) );

    	
        if( $_POST['sender'] )
        {
            $birth_day   = (int)$_POST['day'];
            $birth_month = (int)$_POST['month'];
            $birth_year  = (int)$_POST['year'];
            $email1      = $_POST['email1'];    
            $email2      = $_POST['email2'];
            $pass1       = trim( $_POST['pass1'] );    
            $pass2       = trim( $_POST['pass2'] );
            $gender      = $_POST['gender'];
            $nick        = trim( htmlspecialchars( $_POST['nickname'] ) );
            $nick_low    = mb_strtolower( $nick, 'UTF-8' );    
            $page        = trim( $_POST['page'] );
        
            if( $gender != 'male' && $gender != 'female' )
                $errors['gender_format'] = true;
                
            if( $birth_month < 1 || $birth_month > 12 )
                $errors['birth_date1'] = true;
        
            if( $birth_day > $months[$birth_month]['days'] || $birth_day < 1 )
                $errors['birth_date2'] = true;    	    
            
            if( $birth_year > date( 'Y' ) )
                $errors['birth_date2'] = true;             
                
            if( $pass1 != $pass2 )
                $errors['pass_equal'] = true;
                
            if( $pass1 == '' )
                $errors['pass_empty'] = true;    

            if( $email1 != $email2 )
                $errors['email_equal'] = true;
            
            if( RegEx::check_IsEmail( $email1 ) )
            {
                $email = mb_strtolower( $email1, 'UTF-8' );
                $email_check = DBChose::PrepareDriver( 'SELECT `id` FROM  `members` WHERE `email`=:1' );
                $email_check->Execute( $email );
                
                if( $email_check->GetNum() )
                    $errors['email_exist'] = true;
            }
            else
                $errors['email_format'] = true;

            if( RegEx::check_IsLatinNum( $page ) )
            {
                $page = mb_strtolower( $page, 'UTF-8' );
            
                $page_check = DBChose::PrepareDriver( 'SELECT `id` FROM  `members` WHERE `page`=:1' );
                $page_check->Execute( $page );
            
                if( $page_check->GetNum() )
                    $errors['page_exist'] = true;
            }	    
            else
                $errors['page_format'] = true;

            $nick_check = DBChose::PrepareDriver( 'SELECT `id` FROM  `members` WHERE `nick`=:1 OR `nick_low`=:2' );
            $nick_check->Execute( $nick, $nick_low );
            
            if( $nick_check->GetNum() )
                $errors['nick_exist'] = true;
            
            if( isset( $_SESSION['captcha_keystring'] ) && $_SESSION['captcha_keystring'] == $_POST['email3'] )
                unset( $_SESSION['captcha_keystring'], $_POST['email3'] );    
            else
                $errors['captcha'] = 1;
            //PrintArrayDump( $errors );
            if( sizeof( $errors ) == 0 )
            {
                $eactive = md5( microtime().$email );
        
                $salt = User::PassSaltGen();
                $hash = User::PassHashGen( $pass1, $email1, $salt );

            
                //$charset = 'utf-8';
        
                $mail_to = $email1;
        
                $subject = "Подтверждение регистрации Fullrest: SONET";
              

$mail_text = 
"ВНИМАНИЕ!!! Это письмо прислано автоматизированный системой рассылки уведомлений ресурса fullrest.ru. Вы не должны отвечать на данное сообщение.

Если же вы действительно регистрировались на нашем ресурсе, то для активации учетной записи вам следует пройти по ссылке ниже.

Ссылка для активации: ".SHOST.'/registration/confirm/'.$eactive."

Если вы не регистрировались на сайте fullrest.ru и вы не знаете, кто мог указать ваш почтовый ящик во время регистрации, тогда пройдите по ссылке ниже и данный ящик будет удален из нашей базы:

Ссылка для удаления: ".SHOST.'/registration/delete/'.$eactive."

Благодарим за регистрацию на нашем сайте!

С уважение, Fullrest-Team.";
        
                $send = send_my_email( $mail_to, $subject, $mail_text );
                
                $errors['nosend'] = 0;
                
                if( $errors['nosend'] == 0 )
                {                    
                    $birth_unix = mktime( 0 , 0, 0, $birth_month, $birth_day, $birth_year );
                    
                    $birth_date = $birth_year.'-'.$birth_month.'-'.$birth_day;
                    
                    $mem_ins = DBChose::PrepareDriver( 'INSERT INTO `members` ( `nick`, `nick_low`, `email`, `gender`, `page` ) VALUES( :1, :2, :3, :4, :5 )' );
                    $mem_ins->Execute( $nick, $nick_low, $email, $gender, $page  ); 
                    
                    $mem_sel = DBChose::PrepareDriver( 'SELECT * FROM `members` WHERE`email`=:1' );
                    $mem_sel->Execute( $email );

                    $row = $mem_sel->FetchArray();
                    
                    $per_ins = DBChose::PrepareDriver( 'INSERT INTO `members_personal` ( `id`, `birth_date`, `birth_unix` ) VALUES( :1, :2, :3 )' );
                    $per_ins->Execute( $row['id'], $birth_date, $birth_unix ); 
                    
                    
                    $per_hsh = DBChose::PrepareDriver( 'INSERT INTO `members_auth` ( `id`, `salt`, `hash`, `eactive` ) VALUES( :1, :2, :3, :4 )' );
                    $per_hsh->Execute( $row['id'], $salt, $hash, $eactive );   

                    parent::SetReturnCData( 'complete', true );
                }                
            }
            parent::SetReturnCData( 'errors', $errors );
        }
    }
    
    private function module_logout()
    {
    	parent::AddBreadCorn( 'logout', 'Выход', '' );
    	parent::SetTitle( 'Выход' );
    	
    	User::MakeLogout();
    	
    	base_redirect( 0, OldUrl::GetCUrl( 1 ) );
    }
    
    private function registr_delete()
    {
        parent::AddBreadCorn( 'delete',       'Удаление аккаунта', '' );
    	parent::SetTitle( 'Удаление аккаунта' );
    	parent::SetReturnCData( 'title', 'Удаление аккаунта' ); 
        
        if( mb_strlen( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) != 32 )
            return;  	    
            
        $mem_chk = DBChose::PrepareDriver( 'SELECT * FROM `members` , `members_auth` WHERE `members_auth`.`id` = `members`.`id` AND `members_auth`.`eactive` = :1 AND `members`.`group_primary` = \'4\'' );
        $mem_chk->Execute( UrlDecoder::GetCUri( 2 )  ); 

        if( !$mem_chk->GetNum() )
            return;
            
        $row = $mem_chk->FetchArray();
        

        
        $del1 = DBChose::PrepareDriver( 'DELETE FROM `members` WHERE `id`=:1 ' );
        $del1->Execute( $row['id'] );
        
        $del2 = DBChose::PrepareDriver( 'DELETE FROM `members_auth` WHERE `id`=:1 ' );
        $del2->Execute( $row['id'] );
        
        $del3 = DBChose::PrepareDriver( 'DELETE FROM `members_personal` WHERE `id`=:1 ' );
        $del3->Execute( $row['id'] );
        
        if( User::GetId() )
            User::MakeLogout();
            
        parent::SetReturnCData( 'complete', true );
    }
    
    private function registr_activation()
    {
        parent::AddBreadCorn( 'delete',       'Активация аккаунта', '' );
    	parent::SetTitle( 'Активация аккаунта' );
    	parent::SetReturnCData( 'title', 'Активация аккаунта' ); 
        
        if( mb_strlen( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) != 32 )
            return;
            
        $mem_chk = DBChose::PrepareDriver( 'SELECT * FROM `members` , `members_auth` WHERE `members_auth`.`id` = `members`.`id` AND `members_auth`.`eactive` = :1 AND `members`.`group_primary` = \'4\'' );
        $mem_chk->Execute( UrlDecoder::GetCUri( 2 )  ); 

        if( !$mem_chk->GetNum() )
            return;
            
        $row = $mem_chk->FetchArray();

        $update = DBChose::PrepareDriver( 'UPDATE `members` SET `group_primary` = :1, `regdate` = :2  WHERE `members`.`id` =:3 AND `group_primary` = :4 AND `regdate` = :5 ' );
        $update->Execute( 2, date( 'U' ), $row['id'], 4, 0 );
        
        $update2 = DBChose::PrepareDriver( 'UPDATE `members_auth` SET `eactive` = :1  WHERE `members_auth`.`id`=:2' );
        $update2->Execute( 0, $row['id'] );
        
        if( User::GetId() )
            User::ReExecute( User::GetId() );
            
        parent::SetReturnCData( 'complete', true );
    }
    
    private function registr_restore()
    {
        parent::AddBreadCorn( 'restore',       'Восстановление пароля', '' );
    	parent::SetTitle( 'Восстановление пароля' );
    	parent::SetReturnCData( 'title', 'Восстановление пароля' );

    	if( UrlDecoder::GetCUri( 2 ) == 'change' )
    	{
    		$days3   = 60 * 60 *24 * 3;
    		
    		$regdate = date( 'U' ) - $days3;
    		
    		$email_check = DBChose::PrepareDriver( 'SELECT * FROM  `members` WHERE `reminder`=:1 AND `reminder_date` > :2' );
            $email_check->Execute( UrlDecoder::GetCUri( 3 ), $regdate );
            
            if( $email_check->GetNum() )
            {    		
    		    parent::SetReturnCData( 'exist', true );
    		    
    		    $user = $email_check->FetchAssoc();
    		    
    		    if( $_POST['sender'] )
    		    {
                    
    		    	$pass1 = trim( $_POST['pass1'] );    
                    $pass2 = trim( $_POST['pass2'] );
        
                    if( $pass1 != $pass2 )
                        $errors['pass_equal'] = true;
                
                    if( $pass1 == '' )
                        $errors['pass_empty'] = true;    

            
                    if( isset( $_SESSION['captcha_keystring'] ) && $_SESSION['captcha_keystring'] == $_POST['email3'] )
                        unset( $_SESSION['captcha_keystring'], $_POST['email3'] );    
                    else
                        $errors['captcha'] = 1;

                    if( sizeof( $errors ) == 0 )
                    {

                    	$salt = User::PassSaltGen();
                        $hash = User::PassHashGen( $pass1, $user['email'], $salt );
                    	
                        $per_upd = DBChose::PrepareDriver( 'UPDATE `members` SET `reminder`=:2, `eminder_date`=:3 WHERE `id`=:1' );
                        $per_upd->Execute( $user['id'], 0, 0 ); 
                    
                    
                        $per_upd = DBChose::PrepareDriver( 'UPDATE `members_auth` SET `salt`=:2, `hash`=:3 WHERE `id`=:1' );
                        $per_upd->Execute( $user['id'], $salt, $hash );  
                        
                        parent::SetReturnCData( 'complete', true );
                    }
    		    }
            }
    	}
    	else
    	{        
    	    if( $_POST['sender'] )
    	    {
    		    $email = $_POST['email'];
    		
    		    if( RegEx::check_IsEmail( $email ) )
                {
                    $email = mb_strtolower( $email, 'UTF-8' );
                    $email_check = DBChose::PrepareDriver( 'SELECT `id` FROM  `members` WHERE `email`=:1' );
                    $email_check->Execute( $email );
                
                    if( !$email_check->GetNum() )
                        $errors['email_none'] = true;
                }
                else
                    $errors['email_format'] = true;
                
                if( !sizeof( $errors ) )
                {
            	    $reminder = md5( rand( 0, 999999 ).mktime() );
            	
            	    $email_check = DBChose::PrepareDriver( 'UPDATE  `members` SET `reminder`=:2, `reminder_date`=:3 WHERE `email`=:1' );
                    $email_check->Execute( $email, $reminder, date( 'U' ) );
                
                    $subject = "Восстановление пароля Fullrest: SONET";
        
                

                    $mail_text = 
"ВНИМАНИЕ!!! Это письмо прислано автоматизированный системой рассылки уведомлений ресурса fullrest.ru. Вы не должны отвечать на данное сообщение.

Был осущствлен запрос на восстановление пароля. Ссылка ниже будет актуальна в течении 3х дней.

Ссылка для смены пароля: ".SHOST.'/registration/restore/change/'.$reminder."

С уважение, Fullrest-Team.";

        
        
                    $send = send_my_email( $email, $subject, $mail_text ); 
                
                    parent::SetReturnCData( 'complete', true );
                }
    	    }
    	}
            
        parent::SetReturnCData( 'errors', $errors );
    }
}

?>