<?php

class Module extends PModule
{
    public function act_index()
    {
        if( UrlDecoder::GetCUri( 1 ) == '' || UrlDecoder::GetCUri( 1 ) == 'knights-of-the-nine' || UrlDecoder::GetCUri( 1 ) == 'shivering-isles' )
        {
        	$this->main_info();
        	return;
        }
        else
        {
        	$article = DBChose::PrepareDriver( 'SELECT `game_articles`.*, `members`.`page` AS `page`, `members`.`nick` AS `nick`, `members`.`gender` AS `gender`   
    	                                    FROM `game_articles`, `members` 
    	                                    WHERE `game_articles`.`uid`=`members`.`id` AND `game_articles`.`game`=:1 AND `game_articles`.`parent_id`=:2 AND `game_articles`.`name`=:3 AND `game_articles`.`deleted`=:4 AND `game_articles`.`show`=:5 AND `game_articles`.`moderated`=:6 ORDER BY  `game_articles`.`order` ASC ' );
            $article->Execute( 2, 0, UrlDecoder::GetCUri( 1 ), 0, 1, 1 );
            
            if( $article->GetNum() )            	
            	$this->main_article( $article->FetchAssoc() );
            else                       
                TempeltateEngine::GenerateError( 404 ); 
        }
    }
    
    public function act_system()
    {        
        if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	    
    	parent::AddBookMark( SHOST.'/oblivion/system', '',           2, 'Характеристики', 'Подробный разбор основных характеристик и параметров The Elder Scrolls 4: Oblivion', array() );
   	    parent::AddBookMark( SHOST.'/oblivion/system', 'skills',     2, 'Навыки',         'Подробный разбор основных навыков The Elder Scrolls 4: Oblivion',                    array() );
   	    parent::AddBookMark( SHOST.'/oblivion/system', 'classes',    2, 'Профессии',      'Подробный разбор основных профессий The Elder Scrolls 4: Oblivion',                  array() );
   	    parent::AddBookMark( SHOST.'/oblivion/system', 'birthsigns', 2, 'Созвездия',      'Подробный разбор созвездий The Elder Scrolls 4: Oblivion',                           array() );   	    
   	    parent::AddBookMark( SHOST.'/oblivion/system', 'races',      2, 'Расы',           'Подробный разбор основных рас The Elder Scrolls 4: Oblivion',                        array() );
   	    
   	    parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4',  '' );
   	    parent::AddBreadCorn(        'system',    'Ролевая система',      '' );

        
        if( UrlDecoder::GetCUri( 2 ) == '' )
        {        	            
            $attrs = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_attributes`' );
            $attrs->Execute();
            
            for( $a = 0; $a < $attrs->GetNum(); $a++ )
            {
            	$row = $attrs->FetchAssoc();
            	$attributes[$row['id']] = $row;
            }

            $skill = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_skills`' );
            $skill->Execute();
            
            for( $a = 0; $a < $skill->GetNum(); $a++ )
            {
            	$row = $skill->FetchAssoc();
            	$skills[$row['attribute']][] = $row;
            }

            parent::SetReturnCData( 'skills',     $skills     );
            parent::SetReturnCData( 'attributes', $attributes );
            
            parent::SetTitle( 'Характеристики (TES4 Oblivion)' );
            
            parent::SetFlag1( 'chars' );
        }
        else if( UrlDecoder::GetCUri( 2 ) == 'skills' )
        {        	            
            $skill = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_skills` ORDER BY `tes4_skills`.`specialization` ASC' );
            $skill->Execute();
            
            for( $a = 0; $a < $skill->GetNum(); $a++ )
            {
            	$row = $skill->FetchArray();
            	$skills[$row['specialization']][] = $row;
            }            
            
            parent::SetReturnCData( 'skills', $skills );
            
            parent::SetTitle( 'Навыки (TES4 Oblivion)' );
            
            parent::SetFlag1( 'skills' );
        }
        else if( UrlDecoder::GetCUri( 2 ) == 'classes' )
        {        	            
            $skill = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_skills` ORDER BY `tes4_skills`.`specialization` ASC' );
            $skill->Execute();
            
            for( $a = 0; $a < $skill->GetNum(); $a++ )
            {
            	$row = $skill->FetchAssoc();
            	$skills[$row['name']] = $row;
            }

            $class = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_classes` ORDER BY `tes4_classes`.`specialization` ASC' );
            $class->Execute();
            
            for( $a = 0; $a < $class->GetNum(); $a++ )
            {
            	$row = $class->FetchAssoc();
            	$classes[$row['specialization']][] = $row;
            }
            
            $attrs = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_attributes`' );
            $attrs->Execute();
            
            for( $a = 0; $a < $attrs->GetNum(); $a++ )
            {
            	$row = $attrs->FetchAssoc();
            	$attributes[$row['name']] = $row;
            }
            
            parent::SetReturnCData( 'skills',     $skills     );
            parent::SetReturnCData( 'attributes', $attributes );
            parent::SetReturnCData( 'classes',    $classes );
            
            parent::SetTitle( 'Профессии (TES4 Oblivion)' );
            
            parent::SetFlag1( 'classes' );
        }
        else if( UrlDecoder::GetCUri( 2 ) == 'birthsigns' )
        {
        	$sign = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_birthsigns`' );
            $sign->Execute();
            
            for( $a = 0; $a < $sign->GetNum(); $a++ )
            {
            	$signs[$a] = $sign->FetchArray();
            }
            
            parent::SetReturnCData( 'signs',    $signs );
            
            parent::SetTitle( 'Созвездия (TES4 Oblivion)' );
            
            parent::SetFlag1( 'birthsigns' );
        }
        else if( UrlDecoder::GetCUri( 2 ) == 'races' )
        {                                    
            $race = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_races`' );
            $race->Execute();
        
            $skill = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_races_skills`' );
            $skill->Execute();
        
            $stat = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_races_stats`' );
            $stat->Execute();
            
            for( $a = 0; $a < $race->GetNum(); $a++ )
            {
                $row1 = $race->FetchAssoc();
            
                $row2 = $stat->FetchAssoc();
                $row3 = $stat->FetchAssoc();
                
                $row12 = $row2;
                $row13 = $row3;
                
                unset( $row2['rid'], $row2['gender'], $row2['height'], $row2['weight'], 
                       $row3['rid'], $row3['gender'], $row3['height'], $row3['weight'] );
        	
            	$item[$row1['id']]['data']             = $row1;
            	$item[$row12['rid']][$row12['gender']] = $row2;
            	$item[$row13['rid']][$row13['gender']] = $row3;    
            }
        
            for( $a = 0; $a < $skill->GetNum(); $a++ )
            {
                $row = $skill->FetchAssoc();
        	
              	$skills[$row['rid']][$row['skill']] = $row['val'];  	
            }
        
            $attrs = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_attributes`' );
            $attrs->Execute();
            
            for( $a = 0; $a < $attrs->GetNum(); $a++ )
            {
               	$row = $attrs->FetchAssoc();
               	$atlist[$row['name']] = $row;
            }
           
            $skills1 = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_skills`' );
            $skills1->Execute();
           
            for( $a = 0; $a < $skills1->GetNum(); $a++ )
            {
               	$row = $skills1->FetchAssoc();
               	$sklist[$row['name']] = $row;
            }         
            
            $return_array['item']   = $item;
            $return_array['skills'] = $skills;
            $return_array['attrs']  = $atlist;
            $return_array['skill']  = $sklist;
            
            parent::SetReturnData( $return_array );

            parent::SetTitle( 'Расы (TES4 Oblivion)' );
            parent::SetFlag1( 'races' );
        }
        else
            TempeltateEngine::GenerateError( 404 ); 
        
        parent::SetTemplFile( 'tpl_system' );
        
        $this->make_left_menu();
    }
    
    public function act_magiceffects()
    {
    	if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 ); 
                    
    	$check_array = array( '' => 2, 'alteration' => 3, 'illusion' => 4, 'conjuration' => 5, 'mysticism' => 6, 'destruction' => 7 );
   	    
   	    if( $check_array[UrlDecoder::GetCUri( 2 )] < 2  )
   	        TempeltateEngine::GenerateError( 404 );
        
    	parent::AddBookMark( SHOST.'/oblivion/magiceffects', '',            2, 'Восстановление', 'Здесь представленны магические эффекты школы восстановления', array() );
   	    parent::AddBookMark( SHOST.'/oblivion/magiceffects', 'alteration',  2, 'Изменения',      'Здесь представленны магические эффекты школы изменения',      array() );
   	    parent::AddBookMark( SHOST.'/oblivion/magiceffects', 'illusion',    2, 'Иллюзии',        'Здесь представленны магические эффекты школы иллюзий',        array() );
   	    parent::AddBookMark( SHOST.'/oblivion/magiceffects', 'conjuration', 2, 'Колдовство',     'Здесь представленны магические эффекты школы колдовства',     array() );   	    
   	    parent::AddBookMark( SHOST.'/oblivion/magiceffects', 'mysticism',   2, 'Мистицизм',      'Здесь представленны магические эффекты школы мистицизма',     array() );
   	    parent::AddBookMark( SHOST.'/oblivion/magiceffects', 'destruction', 2, 'Разрушение',     'Здесь представленны магические эффекты школы разрушения',     array() );

   	    if( UrlDecoder::GetCUri( 2 ) == '' )
   	        $school = 'restoration';
   	    else
   	        $school = UrlDecoder::GetCUri( 2 );
   	        
   	    $title = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_magic_schools` WHERE `id`=:1' );
        $title->Execute( $check_array[UrlDecoder::GetCUri( 2 )] - 1 );
        
        if( !$title->GetNum() )
            TempeltateEngine::GenerateError( 500 );  

        $trow = $title->FetchAssoc();
        
        $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_magic_effects` WHERE `school`=:1 ORDER BY  `title` ASC ' );
        $items->Execute( $school );
            
        for( $a = 0; $a < $items->GetNum(); $a++ )
             $item[$a] = $items->FetchAssoc();
    	
    	parent::AddBreadCorn(  SHOST.'/oblivion',    'The Elder Scrolls 4',  '' );
   	    parent::AddBreadCorn(        'magiceffects', 'Магические эффекты',   '' );
   	    
   	    parent::SetTitle( 'Магическая школа - '.$trow['title'].' (TES4 Oblivion)' );
   	    
   	    parent::SetReturnCData( 'item',  $item          );
   	    parent::SetReturnCData( 'title', $trow['title'] );  
   	    
   	    parent::SetFlag1( 'magic' );
   	    parent::SetTemplFile( 'tpl_system' );
    	
    	$this->make_left_menu();
    }    
    
    public function act_weapons()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'weapons',     'Оружие',    '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 ); 
    	
    	$allow_list = array(
    	    ''       => array( 'set' => 1, 'title' => 'Клинки',   'descr' => '' ),        
            'blunt'  => array( 'set' => 1, 'title' => 'Дробящее', 'descr' => '' ),
            'bow'    => array( 'set' => 1, 'title' => 'Луки',     'descr' => '' ),         
            'staff'  => array( 'set' => 1, 'title' => 'Посохи',   'descr' => '' )
        );
        
        parent::AddBookMark( SHOST.'/oblivion/weapons', '',      2, 'Клинки',   '', array() );
        parent::AddBookMark( SHOST.'/oblivion/weapons', 'blunt', 2, 'Дробящее', '', array() );
        parent::AddBookMark( SHOST.'/oblivion/weapons', 'bow',   2, 'Луки',     '', array() );
        parent::AddBookMark( SHOST.'/oblivion/weapons', 'staff', 2, 'Посохи',   '', array() );               
        
        $sql_strings = array( 'blade' => '`type`=\'blade_one_hand\' OR `type`=\'blade_two_hand\'', 'blunt' => '`type`=\'blunt_one_hand\' OR `type`=\'blunt_two_hand\'', 'bow' => '`type`=\'bow\'', 'staff' => '`type`=\'staff\'' );
          
        $this->GetEnchItem( $allow_list, 'blade', $sql_strings, 'tes4_weapon', 'items'  );    
      
        parent::SetTitle( $allow_list[UrlDecoder::GetCUri(2)]['title'].' (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', $allow_list[UrlDecoder::GetCUri(2)]['title'] );

        parent::SetTemplFile( 'tpl_items' );
        
        $this->make_left_menu();
    }    
    
    public function act_arrows()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'arrows',      'Стрелы',    '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	
    	$allow_list = array();
        
        $sql_strings = array();
            
        $this->GetEnchItem( $allow_list, '', $sql_strings, 'tes4_ammo', 'single'  );    
    	
    	parent::SetTitle( 'Стрелы (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', 'Стрелы' );
        
    	parent::SetTemplFile( 'tpl_items' );
        
        $this->make_left_menu();
    }
    
    public function act_armors()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'armors',      'Доспехи',    '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	
    	$allow_list = array(
    	    ''          => array( 'set' => 1, 'title' => 'Шлемы',    'descr' => '' ),        
            'cuirass'   => array( 'set' => 1, 'title' => 'Кирасы',   'descr' => '' ),
            'greaves'   => array( 'set' => 1, 'title' => 'Поножи',   'descr' => '' ),         
            'boots'     => array( 'set' => 1, 'title' => 'Ботинки',  'descr' => '' ),
            'shield'    => array( 'set' => 1, 'title' => 'Щиты',     'descr' => '' ),         
            'gauntlets' => array( 'set' => 1, 'title' => 'Перчатки', 'descr' => '' ),         
            'set'       => array( 'set' => 1, 'title' => 'Наборы',   'descr' => '' )
        );
        
        parent::AddBookMark( SHOST.'/oblivion/armors', '',          2, 'Шлемы',    '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'cuirass',   2, 'Кирасы',   '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'greaves',   2, 'Поножи',   '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'boots',     2, 'Ботинки',  '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'shield',    2, 'Щиты',     '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'gauntlets', 2, 'Перчатки', '', array() );
        parent::AddBookMark( SHOST.'/oblivion/armors', 'set',       2, 'Наборы',   '', array() );
        
        $sql_strings = array( 'helmet' => '`type`=\'helmet\'',  'cuirass' => '`type`=\'cuirass\'', 'greaves' => '`type`=\'greaves\'',  'boots' => '`type`=\'boots\'', 'shield' => '`type`=\'shield\'', 'gauntlets' => '`type`=\'gauntlets\'',  'set' => '`type`=\'set\'' );
            
        $this->GetEnchItem( $allow_list, 'helmet', $sql_strings, 'tes4_armors', 'items'  );

        parent::SetTitle( $allow_list[UrlDecoder::GetCUri(2)]['title'].' (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', $allow_list[UrlDecoder::GetCUri(2)]['title'] );

        parent::SetTemplFile( 'tpl_items' );
        
    	$this->make_left_menu();
    }
    
    public function act_cloths()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'cloths',      'Одежда',              '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	
    	$allow_list = array(
    	    ''       => array( 'set' => 1, 'title' => 'Туфли',    'descr' => '' ),        
            'pants'  => array( 'set' => 1, 'title' => 'Штаны',    'descr' => '' ),
            'shirt'  => array( 'set' => 1, 'title' => 'Рубашки',  'descr' => '' ),         
            'robe'   => array( 'set' => 1, 'title' => 'Робы',     'descr' => '' ),
            'hood'   => array( 'set' => 1, 'title' => 'Капюшоны', 'descr' => '' ),         
            'amulet' => array( 'set' => 1, 'title' => 'Амулеты',  'descr' => '' ),
            'ring'   => array( 'set' => 1, 'title' => 'Кольца',   'descr' => '' ),            
            'set'    => array( 'set' => 1, 'title' => 'Наборы',   'descr' => '' )
        );
        
        parent::AddBookMark( SHOST.'/oblivion/cloths', '',       2, 'Туфли',    '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'pants',  2, 'Штаны',    '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'shirt',  2, 'Рубашки',  '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'robe',   2, 'Робы',     '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'hood',   2, 'Капюшоны', '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'amulet', 2, 'Амулеты',  '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'ring',   2, 'Кольца',   '', array() );
        parent::AddBookMark( SHOST.'/oblivion/cloths', 'set',    2, 'Наборы',   '', array() );
        
        $sql_strings = array( 'shoes' => '`type`=\'shoes\'', 'pants' => '`type`=\'pants\'', 'shirt' => '`type`=\'shirt\'', 'robe' => '`type`=\'robe\'', 'hood' => '`type`=\'hood\'', 'amulet' => '`type`=\'amulet\'', 'ring' => '`type`=\'ring\'', 'set' => '`type`=\'set\'' );
            
        $this->GetEnchItem( $allow_list, 'shoes', $sql_strings, 'tes4_clothing', 'items'  );     	

        parent::SetTitle( $allow_list[UrlDecoder::GetCUri(2)]['title'].' (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', $allow_list[UrlDecoder::GetCUri(2)]['title'] );

        parent::SetTemplFile( 'tpl_items' );
        
    	$this->make_left_menu();
    }

    public function act_scrolls()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'scrolls',     'Магические свитки',   '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	
    	$allow_list = array();
        
        $sql_strings = array();
            
        $this->GetEnchItem( $allow_list, '', $sql_strings, 'tes4_scrolls', 'single'  );    
    	
    	parent::SetTitle( 'Магические свитки (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', 'Магические свитки' );
        
    	parent::SetTemplFile( 'tpl_items' );
        
        $this->make_left_menu();
    }
    
    public function act_ingredients()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'ingredients', 'Ингредиенты',         '' );
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	    
    	$sim = DBChose::PrepareDriver( 'SELECT DISTINCT ( LEFT( `title` , 1 ) ) AS `sim` FROM `fullrestu_tes4db`.`tes4_ingredient` ORDER BY `sim` ASC ' );
        $sim->Execute();
        
        for( $a = 0; $a < $sim->GetNum(); $a++ )
        {
            $row    = $sim->FetchArray();
        	
        	if( $index_site == '' )
        	{
         	    $index_site = Translit::EngToRu( Translit::RuToEng( $row['sim'] ) );
         	    $allow_list[''] = array( 'set' => 1,  'url' => '', 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '',         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        	else
        	{
         	    $allow_list[Translit::RuToEng( $row['sim'] )] = array( 'set' => 1,  'url' => Translit::RuToEng( $row['sim'] ), 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), Translit::RuToEng( $row['sim'] ),         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        }        
        
        $symbol = Translit::EngToRu( mb_strtolower( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) );

        if( UrlDecoder::GetCUri( 2 ) == '' )
            $symbol = $index_site;                            
    	
    	$items = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_ingredient` WHERE  LEFT( `title`,1)=:1 ORDER BY  `tes4_ingredient`.`title` ASC ' );                     
        $items->Execute( $symbol );
        
        if( !$items->GetNum() )
            TempeltateEngine::GenerateError( 404 ); 
        
        for( $a = 0; $a < $items->GetNum(); $a++ )
        	$elist[] = $items->FetchAssoc();       	
        
        $items2 = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_ingredient_effects`' );                     
        $items2->Execute();
        
        for( $a = 0; $a < $items2->GetNum(); $a++ )
        {
        	$row = $items2->FetchAssoc();
        	$e_ef_list[$row['ing_id']][] = $row;        	
        }
        
        $this->GetMagicsAttrsSkills();        
            	
    	parent::SetTitle( 'Ингредиенты (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', 'Ингредиенты' );
        parent::SetReturnCData( 'item',  $elist );
        parent::SetReturnCData( 'flist', $e_ef_list );
        
    	parent::SetTemplFile( 'tpl_items' );
        
        $this->make_left_menu();
    }
    
    public function act_alchemy()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'alchemy',     'Алхимические Зелья',         '' ); 

   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	    
    	$sim = DBChose::PrepareDriver( 'SELECT DISTINCT ( LEFT( `title` , 1 ) ) AS `sim` FROM `fullrestu_tes4db`.`tes4_potion` ORDER BY `sim` ASC ' );
        $sim->Execute();
        
        for( $a = 0; $a < $sim->GetNum(); $a++ )
        {
            $row    = $sim->FetchArray();
        	
        	if( $index_site == '' )
        	{
         	    $index_site = Translit::EngToRu( Translit::RuToEng( $row['sim'] ) );
         	    $allow_list[''] = array( 'set' => 1,  'url' => '', 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '',         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        	else
        	{
         	    $allow_list[Translit::RuToEng( $row['sim'] )] = array( 'set' => 1,  'url' => Translit::RuToEng( $row['sim'] ), 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), Translit::RuToEng( $row['sim'] ),         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        }        
        
        $symbol = Translit::EngToRu( mb_strtolower( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) );

        if( UrlDecoder::GetCUri( 2 ) == '' )
            $symbol = $index_site;                             
    	
    	$items = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_potion` WHERE  LEFT( `title`,1)=:1 ORDER BY  `tes4_potion`.`title` ASC ' );                     
        $items->Execute( $symbol );
        
        for( $a = 0; $a < $items->GetNum(); $a++ )
        	$elist[] = $items->FetchArray();       	
        
        $items2 = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_potion_effects`' );                     
        $items2->Execute();
        
        for( $a = 0; $a < $items2->GetNum(); $a++ )
        {
        	$row = $items2->FetchArray();
        	$e_ef_list[$row['pot_id']][] = $row;        	
        }

        $this->GetMagicsAttrsSkills();
        
    	parent::SetTemplFile( 'tpl_items' );
            	
    	parent::SetTitle( 'Алхимические Зелья (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', 'Алхимические Зелья' );
        parent::SetReturnCData( 'item',  $elist );
        parent::SetReturnCData( 'flist', $e_ef_list );
                
        $this->make_left_menu();
    }
    
    public function act_apparatus()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4',   '' );
   	    parent::AddBreadCorn(        'apparatus',   'Алхимические аппараты', '' );     	
    	
    	if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	
    	$allow_list = array(
    	    ''           => array( 'set' => 1, 'title' => 'Перегонные кубы',  'descr' => '' ),        
            'calcinator' => array( 'set' => 1, 'title' => 'Кальцинаторы',     'descr' => '' ),
            'mortar'     => array( 'set' => 1, 'title' => 'Ступки и пестики', 'descr' => '' ),         
            'retort'     => array( 'set' => 1, 'title' => 'Реторы',           'descr' => '' )
        );
        
        parent::AddBookMark( SHOST.'/oblivion/apparatus', '',           2, 'Перегонные кубы',  '', array() );
        parent::AddBookMark( SHOST.'/oblivion/apparatus', 'calcinator', 2, 'Кальцинаторы',     '', array() );
        parent::AddBookMark( SHOST.'/oblivion/apparatus', 'mortar',     2, 'Ступки и пестики', '', array() );
        parent::AddBookMark( SHOST.'/oblivion/apparatus', 'retort',     2, 'Реторы',           '', array() );
        
        if( UrlDecoder::GetCUri( 2 ) == '' )
            $app_type = 'alembic';
        else
            $app_type = UrlDecoder::GetCUri( 2 );
            
        if( !$allow_list[UrlDecoder::GetCUri( 2 )]['set'] )
            TempeltateEngine::GenerateError( 404 ); 

        $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_apparatus` WHERE `type`=:1 ORDER BY  `title` ASC ' );
        $items->Execute( $app_type );
            
        for( $a = 0; $a < $items->GetNum(); $a++ )
            $item[$a] = $items->FetchArray();
            

    	parent::SetTemplFile( 'tpl_items' );
            	
    	parent::SetTitle( $allow_list[UrlDecoder::GetCUri( 2 )]['title'].' (TES4 Oblivion)' );
        parent::SetReturnCData( 'title', $allow_list[UrlDecoder::GetCUri( 2 )]['title'] );
        parent::SetReturnCData( 'item',  $item );     
        
        $this->make_left_menu();
    }    
    
    public function act_sigilstones()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'sigilstones', 'Сигильские камни',           '' );
   	    
   	    parent::SetTitle( 'Сигильские камни ( TES 4: Oblivion )' ); 
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 4 )
    	    TempeltateEngine::GenerateError( 404 );
    	    
    	$sim = DBChose::PrepareDriver( 'SELECT DISTINCT ( LEFT( `title` , 1 ) ) AS `sim` FROM `fullrestu_tes4db`.`tes4_sigilstone` ORDER BY `sim` ASC ' );
        $sim->Execute();
        
        for( $a = 0; $a < $sim->GetNum(); $a++ )
        {
            $row    = $sim->FetchArray();
        	
        	if( $index_site == '' )
        	{
         	    $index_site = Translit::EngToRu( Translit::RuToEng( $row['sim'] ) );
         	    $allow_list[''] = array( 'set' => 1,  'url' => '', 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '',         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        	else
        	{
         	    $allow_list[Translit::RuToEng( $row['sim'] )] = array( 'set' => 1,  'url' => Translit::RuToEng( $row['sim'] ), 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), Translit::RuToEng( $row['sim'] ),         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        }        
        
        $symbol = Translit::EngToRu( mb_strtolower( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) );

        if( UrlDecoder::GetCUri( 2 ) == '' )
            $symbol = $index_site;                            
    	
    	$items = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_sigilstone` WHERE  LEFT( `title`,1)=:1 ORDER BY  `tes4_sigilstone`.`title` ASC ' );                     
        $items->Execute( $symbol );
        
        for( $a = 0; $a < $items->GetNum(); $a++ )
        {
        	$row = $items->FetchAssoc();
        	$elist[] = $row;        	
        }
        
        $items2 = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_sigilstone_effects`' );                     
        $items2->Execute();
        
        for( $a = 0; $a < $items2->GetNum(); $a++ )
        {
        	$row = $items2->FetchAssoc();
        	$e_ef_list[$row['sig_id']][] = $row;        	
        }
        

        $this->GetMagicsAttrsSkills();
        
        parent::SetReturnCData( 'title', 'Сигильские камни' );
        parent::SetReturnCData( 'item',  $elist );
        parent::SetReturnCData( 'flist', $e_ef_list );
        
        parent::SetTemplFile( 'tpl_items' );
        
        $this->make_left_menu();
    }
    

    
    public function act_soulgems()
    {
        parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'soulgems',  'Камни душ',           '' );
   	    
   	    parent::SetTitle( 'Камни душ ( TES 4: Oblivion )' ); 
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 3 )
    	    TempeltateEngine::GenerateError( 404 );    	        	
    	
    	$items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_soulgem` ORDER BY  `title` ASC ' );
        $items->Execute();
            
        for( $a = 0; $a < $items->GetNum(); $a++ )
            $item[$a] = $items->FetchArray();                  


        parent::SetReturnCData( 'title', 'Камни душ' );
        parent::SetReturnCData( 'item',  $item );
        
        parent::SetTemplFile( 'tpl_items' );

        $this->make_left_menu();
    }    
    
  
    
    public function act_soundtrack()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'soundtrack',   'Oblivion Soundtrack',             '' );
   	    
   	    parent::SetTitle( 'Oblivion Soundtrack' ); 
    	
    	parent::SetTemplFile( 'tpl_soundtrack' );
        $this->make_left_menu();
    }
    
    public function act_conceptart()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'conceptart', 'Концепт арт',         '' );
   	    
   	    parent::SetTitle( 'Oblivion Concept Art' ); 
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 3 )
    	    TempeltateEngine::GenerateError( 404 ); 
   	    
   	    $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_conceptart`' );
        $items->Execute();

        for( $a = 0; $a < $items->GetNum(); $a++ )
            $list[] = $items->FetchAssoc();
    	
    	parent::SetReturnData( $list );
        parent::SetTemplFile( 'tpl_images' );
        $this->make_left_menu();
    }
    
    public function act_screenshots()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',  'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'screenshots', 'Скриншоты',         '' );
   	    
   	    parent::SetTitle( 'Oblivion ScreenShots' ); 
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 3 )
    	    TempeltateEngine::GenerateError( 404 ); 
   	    
   	    $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_screenshots`' );
        $items->Execute();

        for( $a = 0; $a < $items->GetNum(); $a++ )
            $list[] = $items->FetchAssoc();
    	
    	parent::SetReturnData( $list );
        parent::SetTemplFile( 'tpl_images' );
        $this->make_left_menu();
    }
    
    public function act_wallpapers()
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',  'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'wallpapers',  'Обои на рабочий стол',         '' );
   	    
   	    parent::SetTitle( 'Обои на рабочий стол' ); 
   	    
   	    if( count( UrlDecoder::GetUri() ) >= 3 )
    	    TempeltateEngine::GenerateError( 404 ); 
   	    
   	    $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_wallpapers' );
        $items->Execute();        

        for( $a = 0; $a < $items->GetNum(); $a++ )
            $list[] = $items->FetchAssoc();
    	
    	parent::SetReturnData( $list );
        parent::SetTemplFile( 'tpl_images' );
        $this->make_left_menu();
    }
    
    public function act_books()
    {  
    	
    	if( sizeof( UrlDecoder::GetUri() ) > 3 )
            TempeltateEngine::GenerateError( 404 ); 
    	
    	parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4', '' );
   	    parent::AddBreadCorn(        'books',   'Книги',             '' );
   	    
    	$sim = DBChose::PrepareDriver( 'SELECT DISTINCT ( LEFT( `title` , 1 ) ) AS `sim` FROM `fullrestu_tes4db`.`tes4_books` ORDER BY `sim` ASC ' );
        $sim->Execute();
        
        for( $a = 0; $a < $sim->GetNum(); $a++ )
        {
            $row    = $sim->FetchArray();
        	
        	if( $index_site == '' )
        	{
         	    $index_site = Translit::EngToRu( Translit::RuToEng( $row['sim'] ) );
         	    $allow_list[''] = array( 'set' => 1,  'url' => '', 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '',         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        	else
        	{
         	    $allow_list[Translit::RuToEng( $row['sim'] )] = array( 'set' => 1,  'url' => Translit::RuToEng( $row['sim'] ), 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	    parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), Translit::RuToEng( $row['sim'] ),         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	}
        }        
        
        $symbol = Translit::EngToRu( mb_strtolower( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) );

        if( UrlDecoder::GetCUri( 2 ) == '' )
            $symbol = $index_site;       
            
        
        
        if(  $symbol != '' )
        {
            $books = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_books` WHERE  LEFT( `title`,1)=:1 ORDER BY `title` ASC' );
            $books->Execute( $symbol );

            if( !$allow_list[UrlDecoder::GetCUri( 2 )]['set'] || !$books->GetNum() )
                TempeltateEngine::GenerateError( 404 );           
             
            for( $a = 0; $a < $books->GetNum(); $a++ )
               $lbook[$a] = $books->FetchArray();
                
            $return_array['books'] = $lbook;
            $return_array['title'] = 'Книги на букву "'.mb_strtoupper( $symbol, 'UTF-8' ).'"';
            
            parent::SetTitle( 'Книги на букву "'.mb_strtoupper( $symbol, 'UTF-8' ).'"' );                         
        }
        else
        {
            $books = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_books` WHERE  name=:1' );
            $books->Execute( UrlDecoder::GetCUri( 2 ) );

            if( $books->GetNum() != 1 )
                TempeltateEngine::GenerateError( 404 );   
            
            $row = $books->FetchArray();
            

            $return_array['title']      = $row['title'];
            $return_array['book_title'] = $row['title'];
            $return_array['book_text']  = $row['text'];
            
            parent::SetTitle( 'Книга "'.$row['title'].'"'.' (TES4 Oblivion)' ); 
            
            parent::SetFlag1( 'book' );
        }                        

        parent::SetReturnData( $return_array );
    	
    	parent::SetTemplFile( 'tpl_books' );    	  
        
    	$this->make_left_menu();
    }    
    
    private function main_info()
    {
    	if( UrlDecoder::GetCUri( 1 ) == '' )
    	    $text_name = 'oblivion';
    	else
    	    $text_name = UrlDecoder::GetCUri( 1 );
    	
    	if( count( UrlDecoder::GetUri() ) >= 3 )
    	    TempeltateEngine::GenerateError( 404 ); 
    	    
        parent::AddBreadCorn(  SHOST.'/oblivion', 'The Elder Scrolls 4',  '' );
    	    
    	$get_text = DBChose::PrepareDriver( 'SELECT * FROM  `fullrestu_tes4db`.`tes4_games` WHERE `name`=:1' );
        $get_text->Execute( $text_name );
        
        $data = $get_text->FetchAssoc();
        
        parent::SetTitle( $data['title'] );
        
        
        parent::SetReturnData( $data );
        
        parent::SetTemplFile( 'tpl_introduction' );
        $this->make_left_menu();
    }
    
    private function main_article( $arow )
    {
    	parent::AddBreadCorn(  SHOST.'/oblivion',   'The Elder Scrolls 4',  ''                   );
    	parent::AddBreadCorn(        $arow['name'],  $arow['title'],         $arow['description'] );
    	
    	$article = DBChose::PrepareDriver( 'SELECT `game_articles`.*, `members`.`page` AS `page`, `members`.`nick` AS `nick`, `members`.`gender` AS `gender`   
    	                                    FROM `game_articles`, `members` 
    	                                    WHERE `game_articles`.`uid`=`members`.`id` AND `game_articles`.`game`=:1 AND `game_articles`.`parent_id`=:2 AND `game_articles`.`deleted`=:3 AND `game_articles`.`show`=:4 AND `game_articles`.`moderated`=:5 
    	                                    ORDER BY  `game_articles`.`order` ASC ' );
        $article->Execute( 2, $arow['artic_id'], 0, 1, 1 );
        
        if( $article->GetNum() )
        {
        	if( count( UrlDecoder::GetUri() ) >= 4 )
    	        TempeltateEngine::GenerateError( 404 );
    	        
        	$setted = 0;
        	
        	for( $a = 0; $a < $article->GetNum(); $a++ )
        	{
        		$row = $article->FetchAssoc();
        		
        		if( $a == 0 && UrlDecoder::GetCUri( 2 ) == '' )
        		{
        			$return_data['article'] = $row;
        			$setted = 1;
        			parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '', 2, $row['title'],   $row['description'], array() );
        		}
        		else if( UrlDecoder::GetCUri( 2 ) == $row['name'] )
        		{
        			$return_data['article'] = $row;
        			$setted = 1;
        			parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), $row['name'], 2, $row['title'],   $row['description'], array() );
        		}
        		else
        			parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), $row['name'], 2, $row['title'],   $row['description'], array() );
        	}  

        	if( !$setted )
        	    TempeltateEngine::GenerateError( 404 );
        }
        else
        {
        	if( count( UrlDecoder::GetUri() ) >= 3 )
    	        TempeltateEngine::GenerateError( 404 );
    	        
    	    $return_data['article'] = $arow;
        }
            
    	parent::SetTitle( $return_data['article']['title'].' (TES3: Morrowind)' );
    	parent::SetReturnData( $return_data );
    	
    	parent::SetTemplFile( 'tpl_articles' );
        $this->make_left_menu();
    }

   
    private function GetMagicsAttrsSkills()
    {
        $skill = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_skills`' );
        $skill->Execute();
            
        for( $a = 0; $a < $skill->GetNum(); $a++ )
        {
            $row = $skill->FetchAssoc();
            $skills[$row['id']] = $row;
        }
            
        $attrs = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_attributes`' );
        $attrs->Execute();
            
        for( $a = 0; $a < $attrs->GetNum(); $a++ )
        {
            $row = $attrs->FetchAssoc();
            $attributes[$row['id']] = $row;
        }
            
        $meffs = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_magic_effects`' );
        $meffs->Execute();
            
        for( $a = 0; $a < $meffs->GetNum(); $a++ )
        {
            $row = $meffs->FetchAssoc();
            $magic_effects[$row['id']] = $row;
        }

        
        parent::SetReturnCData( 'attributes', $attributes );
        parent::SetReturnCData( 'magic_effs', $magic_effects );
        parent::SetReturnCData( 'skills',     $skills );
    }

    private function GetEnchants( $ench_arr )
    {
        $ench_sql1 = implode( ' OR ', $ench_arr );
        
        $eitems1 = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_magic_enchants` WHERE '.$ench_sql1 );                     
        $eitems1->Execute();
            
        $ench_arr2 = array();
            
        for( $a = 0; $a < $eitems1->GetNum(); $a++ )
        {
            $row = $eitems1->FetchAssoc();
            	
            $ench_arr2[] = ' `ench_id`=\''.$row['id'].'\' ';
            	
            $elist[$row['ename']] = $row;
        }
            
        $ench_sql2 = implode( ' OR ', $ench_arr2 );
        
        $eitems2 = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`tes4_magic_enchants_effects` WHERE '.$ench_sql2 );                     
        $eitems2->Execute();
            
        $ench_arr2 = array();
            
        for( $a = 0; $a < $eitems2->GetNum(); $a++ )
        {
            	$row = $eitems2->FetchAssoc();            	
            	$e_ef_list[$row['ench_id']][] = $row;
        }
                    
        parent::SetReturnCData( 'elist', $elist     );
        parent::SetReturnCData( 'flist', $e_ef_list );
    }

    private function GetEnchItem( $allow_list = array(), $index, $sql_strings = array(), $db_table, $mode  )
    {
    	if( $mode == 'single' )
    	{
            $sim = DBChose::PrepareDriver( 'SELECT DISTINCT ( LEFT( `title` , 1 ) ) AS `sim` FROM `fullrestu_tes4db`.`'.$db_table.'` ORDER BY `sim` ASC ' );
            $sim->Execute();
        
            for( $a = 0; $a < $sim->GetNum(); $a++ )
            {
                $row    = $sim->FetchArray();
        	
        	    if( $index_site == '' )
        	    {
         	        $index_site = Translit::EngToRu( Translit::RuToEng( $row['sim'] ) );
         	        $allow_list[''] = array( 'set' => 1,  'url' => '', 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	        parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), '',         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	    }
        	    else
        	    {
         	        $allow_list[Translit::RuToEng( $row['sim'] )] = array( 'set' => 1,  'url' => Translit::RuToEng( $row['sim'] ), 'lvl' => 1, 'title' => $row['sim'], 'descr' => 'Переход на страницу '.Translit::RuToEng( $row['sim'] ), 'ajax' => 0  ); 
         	        parent::AddBookMark( SHOST.'/oblivion/'.UrlDecoder::GetCUri( 1 ), Translit::RuToEng( $row['sim'] ),         2,  $row['sim'],    'Переход на страницу '.Translit::RuToEng( $row['sim'] ), array() );
        	    }
            }        
        
            $symbol = Translit::EngToRu( mb_strtolower( UrlDecoder::GetCUri( 2 ), 'UTF-8' ) );

            if( UrlDecoder::GetCUri( 2 ) == '' )
                $symbol = $index_site;                             
    	
    		
    		$items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`'.$db_table.'` WHERE  LEFT( `title`,1)=:1 ORDER BY  `enchanting` ASC ' );                     
            $items->Execute( $symbol );
        
            $ench_arr = array();
        
            for( $a = 0; $a < $items->GetNum(); $a++ )
            {
        	    $row = $items->FetchAssoc();
        	
        	    if( $row['enchanting'] != '' )
        		    $ench_arr[] = ' `ename`=\''.$row['enchanting'].'\' ';
        	
                $weap_list[] = $row;
            }
        
            
            $this->GetEnchants( $ench_arr );           
            $this->GetMagicsAttrsSkills();
            
            parent::SetReturnCData( 'item', $weap_list );		
    	}
    	else if( $mode == 'items' )
    	{
    	    if( UrlDecoder::GetCUri( 2 ) == '' )
                $item_type = $index;
            else
                $item_type = UrlDecoder::GetCUri( 2 );
            
            $items = DBChose::PrepareDriver( 'SELECT * FROM `fullrestu_tes4db`.`'.$db_table.'` WHERE '.$sql_strings[$item_type].' AND `master`=\'1\' ORDER BY  `enchanting` ASC ' );                     
            $items->Execute();
        
            $ench_arr = array();
        
            for( $a = 0; $a < $items->GetNum(); $a++ )
            {
        	    $row = $items->FetchAssoc();
        	
        	    if( $row['enchanting'] != '' )
        		    $ench_arr[] = ' `ename`=\''.$row['enchanting'].'\' ';
        	
                $weap_list[] = $row;
            }
        
            
            $this->GetEnchants( $ench_arr );           
            $this->GetMagicsAttrsSkills();
            
            parent::SetReturnCData( 'item', $weap_list );
    	}        
    } 
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    
    

    private function make_left_menu()
    {
   	    parent::SetMenuLeft( 1, 0 );
    	
    	parent::AddMenuLeft_head( 'main', 'Общая информация' ); 

   	    parent::AddMenuLeft_item( 'main', SHOST.'/oblivion', '',                    1, 'Введение',             '', array() );
   	    parent::AddMenuLeft_item( 'main', SHOST.'/oblivion', 'knights-of-the-nine', 1, 'Knights of the Nine',  '', array() );
   	    parent::AddMenuLeft_item( 'main', SHOST.'/oblivion', 'shivering-isles',     1, 'Shivering Isles',      '', array() );
   	    parent::AddMenuLeft_item( 'main', SHOST.'/oblivion', 'system',              1, 'Ролевая система', '', array() );
   	    parent::AddMenuLeft_item( 'main', SHOST.'/oblivion', 'magiceffects',        1, 'Маг. эффекты',    '', array() );   	    
   	    
   	    parent::AddMenuLeft_head( 'main2', 'База знаний' ); 

   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'weapons',     1, 'Оружие',           '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'arrows',      1, 'Стрелы',           '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'armors',      1, 'Доспехи',          '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'cloths',      1, 'Одежда',           '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'scrolls',     1, 'Маг. свитки',      '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'ingredients', 1, 'Ингредиенты',      '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'alchemy',     1, 'Алхим. зелья',     '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'apparatus',   1, 'Алхим. аппараты',  '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'soulgems',    1, 'Камни душ',        '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'sigilstones', 1, 'Сигильские камни', '', array() );
   	    parent::AddMenuLeft_item( 'main2', SHOST.'/oblivion', 'books',       1, 'Книги',            '', array() );	       	    
   	    
        $solutions1 = DBChose::PrepareDriver( 'SELECT * FROM `game_articles` WHERE `game`=:1 AND `type`=:2 AND `parent_id`=:3 AND `deleted`=:4 AND `show`=:5 AND `moderated`=:6 ORDER BY  `game_articles`.`order` ASC ' );
        $solutions1->Execute( 2, 1, 0, 0, 1, 1 );
        
        if( $solutions1->GetNum() )
        {
        	parent::AddMenuLeft_head( 'main4', 'Статьи' ); 
        	
        	for( $a = 0; $a < $solutions1->GetNum(); $a++ )
        	{
        		$row = $solutions1->FetchAssoc();
        		parent::AddMenuLeft_item( 'main4', SHOST.'/oblivion', $row['name'],    1, $row['title'], $row['description'], array() );
        	}
        }
   	    
   	    $solutions2 = DBChose::PrepareDriver( 'SELECT * FROM `game_articles` WHERE `game`=:1 AND `type`=:2 AND `parent_id`=:3 AND `deleted`=:4 AND `show`=:5 AND `moderated`=:6 ORDER BY  `game_articles`.`order` ASC ' );
        $solutions2->Execute( 2, 2, 0, 0, 1, 1 );
        
        if( $solutions2->GetNum() )
        {
        	parent::AddMenuLeft_head( 'main5', 'Прохождения' );
        	
        	for( $a = 0; $a < $solutions2->GetNum(); $a++ )
        	{
        		$row = $solutions2->FetchAssoc();
        		parent::AddMenuLeft_item( 'main5', SHOST.'/oblivion', $row['name'],    1, $row['title'], $row['description'], array() );
        	}
        }
   	    
        $solutions3 = DBChose::PrepareDriver( 'SELECT * FROM `game_articles` WHERE `game`=:1 AND `type`=:2 AND `parent_id`=:3 AND `deleted`=:4 AND `show`=:5 AND `moderated`=:6 ORDER BY  `game_articles`.`order` ASC ' );
        $solutions3->Execute( 2, 3, 0, 0, 1, 1 );
        
        if( $solutions3->GetNum() )
        {
        	parent::AddMenuLeft_head( 'main6', 'Руководства' );
        	
        	for( $a = 0; $a < $solutions3->GetNum(); $a++ )
        	{
        		$row = $solutions3->FetchAssoc();
        		parent::AddMenuLeft_item( 'main6', SHOST.'/oblivion', $row['name'],    1, $row['title'], $row['description'], array() );
        	}
        }
   	    
   	    
   	     
   	    
   	    parent::AddMenuLeft_head( 'main3', 'Дополнительно' ); 

   	    parent::AddMenuLeft_item( 'main3', SHOST.'/oblivion', 'soundtrack',  1, 'Саундтрек',   '', array() );
   	    parent::AddMenuLeft_item( 'main3', SHOST.'/oblivion', 'conceptart',  1, 'Концепт арт', '', array() );
   	    parent::AddMenuLeft_item( 'main3', SHOST.'/oblivion', 'screenshots', 1, 'Скриншоты',   '', array() );
   	    parent::AddMenuLeft_item( 'main3', SHOST.'/oblivion', 'wallpapers',  1, 'Обои',        '', array() );   	
    }

        
}